# xspin
# File menu support

set file ""

proc file_ok {f} {
	if [file exists $f] {
		if "![file isfile $f] || ![file writable $f]" {
			show_log
			add_log "error: file $f is not writable"
			return 0
	}	}
	return 1
}

proc save_spec {} {
	set fname [.menu.name get]
	if [file_ok $fname]==0 return
	set fd [open $fname w]
	add_log "<save spec in $fname>"
	puts $fd "[.inp.t get 0.0 end]" nonewline
	catch "flush $fd"
	catch "close $fd"
}

proc browse {} {
	global file
	catch {destroy .b}
	toplevel .b

	wm iconname .b "Load"

	scrollbar .b.scroll -command ".b.list yview"
	listbox .b.list -yscroll ".b.scroll set" -relief raised -geometry 20x20
	pack append .b \
		.b.scroll {right filly} \
		.b.list {left expand fill}

	fillerup
	bind .b.list <Double-Button-1> {
		set file [selection get]
		if [file isdirectory $file] then {
			cd $file
			fillerup
			add_log "cd $file"
		} else {
			if ![file isfile $file] {
				set file ""
			} else {
				readinfile
				destroy .b
			}
		}
	}
}

proc reopen {{ verbose 1 }} {
	global file

	set file [.menu.name get]
	catch {readinfile} ermsg
	if [string length $ermsg]==0 return
	if {$verbose} then { show_log }
	add_log $ermsg
}

proc readinfile {} {
	global file

	.inp.t delete 0.0 end
	set fd [open $file r]
	
	while {[gets $fd line] > -1} {
		.inp.t insert end "$line\n"
	}
	catch "close $fd"

	set dir [pwd]
	.menu.name delete 0 end
	.menu.name insert end "$file"

	add_log "<open $file>"
}

proc fillerup {} {
	wm title .b [pwd]
	.b.list delete 0 end
	foreach i [exec ls -a "."] {
		if [string compare $i "."] {
			.b.list insert end $i
		}
	}
}
