/***** spin: pangen1.h *****/

/* Copyright (c) 1991 by AT&T Bell Telephone Laboratories, Inc.           */
/* All Rights Reserved. This software is for educational purposes only.   */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */

char *Header[] = {
	"#define qptr(x)	(((uchar *)&now)+q_offset[x])",
	"#define pptr(x)	(((uchar *)&now)+proc_offset[x])",
	"#define Pptr(x)	((proc_offset[x])?pptr(x):noptr)",
	"#define q_sz(x)	(((Q0 *)qptr(x))->Qlen)\n",
	"#define MAXQ   	255",
	"#define MAXPROC	255",
	"#define WS		sizeof(long)   /* word size in bytes */",
	"#ifndef VECTORSZ",
	"#define VECTORSZ	1024           /* sv   size in bytes */",
	"#endif",
	"extern char *malloc(), *memcpy(), *memset();",
	"extern void exit();",
	"extern int abort();\n",
	"typedef struct Stack  {	 /* for queues and processes */",
	"	short o_delta;",
	"	short o_offset;",
	"	short o_skip;",
	"	short o_delqs;",
	"	char *body;",
	"	struct Stack *nxt;",
	"	struct Stack *lst;",
	"} Stack;\n",
	"typedef struct Svtack { /* for complete state vector */",
	"	short o_delta;	 /* current size of frame */",
	"	short m_delta;	 /* maximum size of frame */",
	"#if SYNC",
	"	short o_boq;",
	"#endif",
	"	int j1, j2;	/* loop detection */",
	"	char *body;",
	"	struct Svtack *nxt;",
	"	struct Svtack *lst;",
	"} Svtack;\n",
	"typedef struct Trans {",
	"	short atom;	/* is this an atomic transition */",
	"	short st;	/* the nextstate */",
	"	short ist;	/* intermediate state */",
	"	char *tp;	/* the type of state, e.g. `r', `s' etc */",
	"	int forw;	/* index for forward transition */",
	"	int back;	/* index for return  transition */",
	"	struct Trans *nxt;",
	"} Trans;\n",
	"Trans ***trans;	/* 1 ptr per state per proctype */\n",
	"int depthfound = -1;	/* loop detection */",
	"short proc_offset[MAXPROC], proc_skip[MAXPROC];",
	"short q_offset[MAXQ], q_skip[MAXQ];",
	"short vsize;		/* vector size in bytes */",
	"short boq = -1;	/* blocked_on_queue status */",
	"typedef struct State {",
	"	uchar _nr_pr;",
	"	uchar _nr_qs;",
	"	uchar _p_t; /* non-progress detection magic bit */",
	"	uchar _a_t; /* acceptance cycle dectection */",
	0,
};

char *Addp0[] = {
	/* addproc(....parlist... */ ")",
	"{",
	"	int j, h = now._nr_pr;",
	"	if (h >= MAXPROC)",
	"		Uerror(\"too many processes\");",
	"	switch (n) {",
	"	case 0: j = sizeof(P0); break;",
	0,
};

char *Addp1[] = {
	"	default: Uerror(\"bad proc - addproc\");",
	"	}",
	"	if (vsize%%WS && (j > WS-(vsize%%WS)))",
	"	{	proc_skip[h] = WS-(vsize%%WS);",
	"		vsize += proc_skip[h];",
	"	} else",
	"		proc_skip[h] = 0;",
	"	proc_offset[h] = vsize;",
	"	now._nr_pr += 1;",
	"	vsize += j;",
	"	hmax = max(hmax, vsize);",
	"	if (vsize >= VECTORSZ)",
	"		Uerror(\"VECTORSZ is too small, edit pan.h\");",
	"	memset((char *)pptr(h), 0, j);",
	"	switch (n) {",
	0,
};

char *Addq0[] = {
	"addqueue(n)",
	"{	int j=0, i = now._nr_qs;",
	"	if (i >= MAXQ)",
	"		Uerror(\"too many queues\");",
	"	switch (n) {",
	0,
};

char *Addq1[] = {
	"	default: Uerror(\"bad queue - addqueue\");",
	"	}",
	"	if (vsize%%WS && (j > WS-(vsize%%WS)))",
	"	{	q_skip[i] = WS-(vsize%%WS);",
	"		vsize += q_skip[i];",
	"	} else",
	"		q_skip[i] = 0;",
	"	q_offset[i] = vsize;",
	"	now._nr_qs += 1;",
	"	vsize += j;",
	"	hmax = max(hmax, vsize);",
	"	if (vsize >= VECTORSZ)",
	"		Uerror(\"VECTORSZ is too small, edit pan.h\");",
	"	memset((char *)qptr(i), 0, j);",
	"	((Q0 *)qptr(i))->_t = n;",
	"	return i+1;",
	"}\n",
	0,
};

char *Addq11[] = {
	"{	int j; uchar *z;\n",
	"	if (!into--)",
	"	uerror(\"reference to uninitialized chan name (sending)\");",
	"	if (into >= now._nr_qs || into < 0)",
	"		Uerror(\"qsend bad queue#\");",
	"	z = qptr(into);",
	"	switch (((Q0 *)qptr(into))->_t) {",
	0,
};

char *Addq2[] = {
	"	case 0: printf(\"queue was deleted\\n\");",
	"	default: Uerror(\"bad queue - qsend\");",
	"	}",
	"}\n",
	"#if SYNC",
	"q_zero(from)",
	"{	if (!from--)",
	"	uerror(\"reference to uninitialized chan name (receiving)\");",
	"	switch(((Q0 *)qptr(from))->_t) {",
	0,
};

char *Addq3[] = {
	"	case 0: printf(\"queue was deleted\\n\");",
	"	}",
	"	Uerror(\"bad queue q-zero\");",
	"}",
	"#endif",
	"q_len(x)",
	"{	if (!x--) uerror(\"reference to uninitialized chan name\");",
	"	return ((Q0 *)qptr(x))->Qlen;",
	"}\n",
	"q_full(from)",
	"{	if (!from--)",
	"	uerror(\"reference to uninitialized chan name (sending)\");",
	"	switch(((Q0 *)qptr(from))->_t) {",
	0,
};

char *Addq4[] = {
	"	case 0: printf(\"queue was deleted\\n\");",
	"	}",
	"	Uerror(\"bad queue - q_full\");",
	"}\n",
	"qrecv(from, slot, fld, done)",
	"{	uchar *z;",
	"	int j, k, r=0;",
	"	if (!from--)",
	"	uerror(\"reference to uninitialized chan name (receiving)\");",
	"	if (from >= now._nr_qs || from < 0)",
	"		Uerror(\"qrecv bad queue#\");",
	"	z = qptr(from);",
	"	switch (((Q0 *)qptr(from))->_t) {",
	0,
};

char *Addq5[] = {
	"	case 0: printf(\"queue was deleted\\n\");",
	"	default: Uerror(\"bad queue - qrecv\");",
	"	}",
	"	return r;",
	"}\n",
	0,
};

char *Code0[] = {
	"run()",
	"{	memset((char *)&now, 0, sizeof(State));",
	"	vsize = sizeof(State) - VECTORSZ;",
	"	settable();",
	0,
};
char *Code1[] = {
	"#define CONNECT	%d /* accept labels */",
	0,
};
char *Code2[] = {
	"	UnBlock;	/* disable rendez-vous */",
	"#ifdef BITSTATE",
	"	SS = (uchar *) emalloc(1<<(ssize-3));",
	"	if (loops)",
	"	LL = (uchar *) emalloc(1<<(ssize-3));",
	"#else",
	"	hinit();",
	"#endif",
	"	stack	= ( Stack *) emalloc(sizeof(Stack));",
	"	svtack	= (Svtack *) emalloc(sizeof(Svtack));",
	"	/* a place to point for Pptr of non-running procs: */",
	"	noptr	= (uchar *) emalloc(Maxbody * sizeof(char));",
	"	addproc(0);	/* init */",
	"	depth=mreached=0;",
	"	trpt = &trail[depth];",
	"	new_state();",
	"}\n",
	"new_state()",
	"{	register Trans *t;",
	"	char n, m, ot;",
	"	short II, tt;\n",
	"	short From = now._nr_pr-1;",
	"	short To = 0;",
	"Down:",
	"	if (now._p_t && prognow()) /* loop detection */",
	"		goto Up;",
	"	if (depth >= maxdepth)",
	"	{	truncs++;",
	"#if SYNC",
	"		(trpt+1)->o_n = 1; /* not a deadlock */",
	"#endif",
	"		goto Up;",
	"	}",
	"#ifdef VERI",
	"	if (!(trpt->tau&4))	/* if no claim move */",
	"#endif",
	"	if (boq == -1)		/* if not mid-rv */",
	"	if (!(trpt->tau&8))	/* if no atomic move */",
	"	{",
	"#ifdef BITSTATE",
	"		d_hash((uchar *) &now, vsize);",
	"		j3 = (1<<(J1&7)); j1 = J1>>3;",
	"		j4 = (1<<(J2&7)); j2 = J2>>3;",
	"		if ((SS[j2]&j3) && (SS[j1]&j4))",
	"#else",
	"		if (hstore((char *)&now, vsize))",
	"#endif",
	"		{	truncs++;",
	"#if CONNECT>0",
	"			if (now._a_t && depth > A_depth)",
	"			{	if (memcmp((char *)&A_Root, (char *)&now, vsize) == 0)",
	"				{	if (fair_cycle())",
	"					uerror(\"acceptance cycle\");",
	"					goto Up;",
	"				}",
	"			}",
	"#endif",
	"#ifdef BITSTATE",
	"			if (loops && now._p_t",
	"			&& LL[j1] && LL[j2] && onstack())",
	"				if (fair_cycle())",
	"				uerror(\"non-progress cycle\");",
	"#endif",
	"			goto Up;",
	"		}",
	"#ifdef BITSTATE",
	"		SS[j2] |= j3; SS[j1] |= j4;",
	"		if (loops)",
	"		{	sv_save();",
	"			LL[j1]++; LL[j2]++;",
	"			svtack->j1 = J1;",
	"			svtack->j2 = J2;",
	"		}",
	"#endif",
	"		nstates++;",
	"	}",
	"	if (depth > mreached)",
	"		mreached = depth;",
	"	trpt->tau &= ~1; n = 0;",
	"#if SYNC",
	"	(trpt+1)->o_n = 0;",
	"#endif",
	"#ifdef VERI",
	"	if (now._nr_pr < 2",
	"	|| ((P0 *)pptr(1))->_p == endclaim)",
	"		uerror(\"claim violated!\");",
	"	if (stopstate[VERI][((P0 *)pptr(1))->_p])",
	"		uerror(\"endstate in claim reached\");",
	"Stutter:",
	"	if (trpt->tau&4)	/* must make a claimmove */",
	"	{	II = 1;",
	"		goto Veri0;",
	"	}",
	"#endif",
	"\nAgain:",
	"	for (II = From; II >= To; II -= 1)",
	"	{",
	"#ifdef VERI",
	"		if (II == 1) continue;",
	"#endif",
	"Veri0:		this = pptr(II);",
	"		tt = (short) ((P0 *)this)->_p;",
	"		ot = (uchar) ((P0 *)this)->_t;",
	"		for (t = trans[ot][tt]; t; t = t->nxt)",
	"		{",
	"#include \"pan.m\"",
	"P999:			/* jumps here when move succeeds */",
	"#ifdef VERBOSE",
	"	printf(\"%%3d: proc %%d exec %%d, from %%d to %%d %%s\\n\", ",
	"		depth, II, t->forw, tt, t->st, t->tp);",
	"#endif",
	"			depth++; trpt++;",
	"			trpt->pr = II;",
	"			trpt->st = tt;",
	"			if (t->st)",
	"			{	((P0 *)this)->_p = t->st;",
	"				reached[ot][t->st] = 1;",
	"			}",
	"			trpt->o_t  =  t; trpt->o_n  = n;",
	"			trpt->o_ot = ot; trpt->o_tt = tt;",
	"			trpt->o_To = To; trpt->o_m  = m;",
	"			trpt->tau = 0;",
	"			if (boq != -1 || t->atom&2)",
	"			{	trpt->tau |= 8;",
	"#ifdef VERI",
	"				if((trpt-1)->tau&4)",
	"					trpt->tau |= 4;",
	"				else",
	"					trpt->tau &= ~4;",
	"			} else",
	"			{	if ((trpt-1)->tau&4)",
	"					trpt->tau &= ~4;",
	"				else",
	"					trpt->tau |= 4;",
	"			}",
	"#else",
	"			} else",
	"				trpt->tau &= ~8;",
	"#endif",
	"			if (boq == -1 && t->atom&2)",
	"			{	From = To = II; nlinks++;",
	"			} else",
	"			{	From = now._nr_pr-1; To = 0;",
	"			}",
	"			goto Down;	/* pseudo-recursion */",
	"Up:",
	"#if CONNECT>0",
	"			if (now._a_t && depth <= A_depth)",
	"				return;	/* we came from checkaccept() */",
	"#endif",
	"			t  = trpt->o_t;  n  = trpt->o_n;",
	"			ot = trpt->o_ot; II = trpt->pr;",
	"			tt = trpt->o_tt; this = pptr(II);",
	"			To = trpt->o_To; m  = trpt->o_m;",
	"#ifdef VERI",
	"#if SYNC",
	"/* preserve rendez-vous completion status: */",
	"/* if the next level was a claim, copy through */",
	"			if (trpt->tau&4)",
	"				trpt->o_n = (trpt+1)->o_n;",
	"#endif",
	"#endif",
	"#include \"pan.b\"",
	"R999:			/* jumps here when done */",
	"#ifdef VERBOSE",
	"	printf(\"%%3d: proc %%d reverses %%d, from %%d to %%d %%s\\n\", ",
	"		depth, II, t->forw, tt, t->st, t->tp);",
	"#endif",
	"			depth--; trpt--;",
	"			if (m>n||(n>3&&m!=0)) n=m;",
	"			((P0 *)this)->_p = tt;",
	"		} /* all options */",
	"#ifdef VERI",
	"		if (II == 1) break;",
	"#endif",
	"	} /* all processes */",
	"	if (n == 0)",
	"	{",
	"#ifdef VERI",
	"		if (trpt->tau&4) goto Done;	/* ok if a claim blocks */",
	"#endif",
	"#if SYNC",
	"		if (boq == -1) {",
	"#endif",
	"		if (!endstate() && now._nr_pr ",
	"		&&  depth < maxdepth-1)",
	"		{	if (!((trpt->tau)&1))	/* timeout */",
	"			{	trpt->tau |= 1;",
	"				goto Again;",
	"			}",
	"#ifdef VERI",
	"#ifdef NOSTUTTER",
	"			if (n >= 0) goto Done;	/* always */",
	"#else",
	"			if (n >= 0)	/* Claim Stutter */",
	"			{	trpt->tau |= 4;		/* claim mark */",
	"				trpt->tau |= 128;	/* Stutter mark */",
	"				goto Stutter;",
	"			}",
	"#endif",
	"#else",
	"			if (loops) goto Done;	/* do loop det. only */",
	"#endif",
	"			if (!(trpt->tau&8))	/* not an atomic move */",
	"			{",
	"#ifdef VERI",
	"				printf(\"claim at\");",
	"				xrefsrc(claimline,1,((P0 *)pptr(1))->_p);",
	"#endif",
	"				uerror(\"invalid endstate\");",
	"			} else",
	"				Uerror(\"atomic seq blocks\");",
	"		}",
	"#ifdef VERI",
	"#ifndef NOSTUTTER",
	"		else",
	"		{	trpt->tau |= 4;		/* claim mark */",
	"			trpt->tau |= 128;	/* Stutter mark */",
	"			goto Stutter;",
	"		}",
	"#endif",
	"#endif",
	"#if SYNC",
	"		}",
	"#endif",
	"	}",
	"Done:",
	"	if (loops && !(trpt->tau&8))",
	"	if (boq == -1)",
	"#ifdef VERI",
	"	if (!(trpt->tau&4))",
	"#endif",
	"#ifdef BITSTATE",
	"	{	LL[(svtack->j1)>>3]--;",
	"		LL[(svtack->j2)>>3]--;",
	"		svtack = svtack->lst;",
	"		if (trpt->tau&2)	/* remove marked state */",
	"		{	SS[(svtack->j2)>>3] &= ~(1<<((svtack->j1)&7));",
	"			SS[(svtack->j1)>>3] &= ~(1<<((svtack->j2)&7));",
	"		}",
	"	}",
	"#else",
	"		htag((char *)&now, vsize);",
	"#endif",
	"#if CONNECT>0",
	"#ifdef VERI",
	"	if ((!(trpt->tau&4))",
	"	||  (trpt->tau&128))	/* no claim move unless Stutter */",
	"#endif",
	"	if (acycles		/* -a option is used */",
	"	&&  !(trpt->tau&8))	/* not an atomic move */",
	"		checkaccept();	/* check for acceptance-cycles */",
	"#endif",
	"	if (depth > 0) goto Up;",
	"}\n",
	"assert(a, s, ii, tt, t)",
	"	char *s;",
	"	Trans *t;",
	"{	if (!a)",
	"	{	printf(\"assertion violated %%s\", s);",
	"		depth++; trpt++;",
	"		trpt->pr = ii;",
	"		trpt->st = tt;",
	"		trpt->o_t = t;",
	"		uerror(\"aborted\");",
	"		depth--; trpt--;",
	"	}",
	"}",
	"#ifndef NOBOUNDCHECK",
	"Boundcheck(x, y, a1, a2, a3)",
	"	Trans *a3;",
	"{	assert((x >= 0 && x < y), \"- invalid array index\\n\", a1, a2, a3);",
	"	return x;",
	"}",
	"#endif",
	"#ifdef MEMCNT",
	"int memcnt=0;",
	"#endif",
	"void",
	"wrapup()",
	"{	double a, b;\n",
	"	printf(\"(%%s)\\n\", Version);",
	"#ifdef BITSTATE",
	"	printf(\"bit statespace search \");",
	"#else",
	"	printf(\"full statespace search \");",
	"#endif",
	"#ifdef VERI",
	"	printf(\"on behavior restricted to claim \");",
	"#endif",
	"	printf(\"for:\\n\tassertion violations\");",
	"#ifndef VERI",
	"	if (loops)",
	"		printf(\" and %%s non-progress loops\",",
	"			fairness?\"FAIR\":\"\");",
	"	else",
	"		printf(\" and invalid endstates\");",
	"#endif",
	"#if CONNECT>0",
	"	if (acycles && !loops)",
	"		printf(\"\\n\\tand %%s acceptance cycles\",",
	"			fairness?\"FAIR\":\"\");",
	"#endif",
	"	if (!done) printf(\"\\nsearch was not completed\");",
	"	printf(\"\\nvector %%d byte, depth reached %%d\", ",
	"					hmax, mreached);",
	"	if (loops)",
	"	  printf(\", non-progress loops: %%d\\n\", errors);",
	"	else",
	"	  printf(\", errors: %%d\\n\", errors);",
	"	printf(\"%%8d states, stored\", nstates - recycled);",
	"	if (recycled) printf(\" (%%d recycled)\", recycled);",
	"	printf(\"\\n%%8d states, linked\\n\", nlinks);",
	"	printf(\"%%8d states, matched\t   total: %%8d\\n\",",
	"	truncs, nstates+nlinks+truncs);",
	"#ifdef BITSTATE",
	"	a = (double) (1<<ssize);",
	"	b = (double) nstates+1.;",
	"	printf(\"hash factor: %%f \", a/b);",
	"	printf(\"(best coverage if >100)\\n\");",
	"#else",
	"	printf(\"hash conflicts: %%d (resolved)\\n\", hcmp);",
	"#endif",
	"	printf(\"(max size 2^%%d states, \", ssize);",
	"	printf(\"stackframes: %%d/%%d)\\n\\n\", smax, svmax);",
	"#ifdef MEMCNT",
	"	printf(\"memory used: %%d\\n\", memcnt);",
	"#endif",
	"	if (done && !loops) do_reach();",
	"	exit(0);",
	"}\n",
	"d_hash(cp, om)",
	"	uchar *cp;",
	"{",
	"	register int z = 0x88888EEF;	/* asuming int = 4 bytes */",
	"	register int *q, *r;",
	"	register int h;",
	"	register m, n;\n",
	"	h = (om+3)/4;",
	"	m = n = -1;",
	"	q = r = (int *) cp;",
	"	r += (int) h;",
	"	do {",
	"		m += m;",
	"		if (m < 0)",
	"			m ^= z;",
	"		m ^= *q++;",
	"		n += n;",
	"		if (n < 0)",
	"			n ^= z;",
	"		n ^= *--r;",
	"	} while (--h > 0);",
	"	J1 = (m ^ (m>>(8*sizeof(int)-ssize)))&mask;",
	"	J2 = (n ^ (n>>(8*sizeof(int)-ssize)))&mask;",
	"}\n",
	"s_hash(cp, om)",
	"	uchar *cp;",
	"{",
	"	register int z = 0x88888EEF;	/* asuming int = 4 bytes */",
	"	register int *q;",
	"	register int h;\n",
	"	register m = -1;",
	"	h = (om+3)/4;",
	"	q = (int *) cp;",
	"	do {",
	"		m += m;",
	"		if (m < 0)",
	"			m ^= z;",
	"		m ^= *q++;",
	"	} while (--h > 0);",
	"	j1 = (m ^ (m>>(8*sizeof(int)-ssize)))&mask;",
	"}\n",
	"main(argc, argv)",
	"	char *argv[];",
	"{",
	"	FILE *efd = stderr;	/* default stderr stream */",
	"	while (argc > 1 && argv[1][0] == '-')",
	"	{	switch (argv[1][1]) {",
	"#if CONNECT>0",
	"		case 'a': acycles = 1; break;",
	"#endif",
	"		case 'c': upto  = atoi(&argv[1][2]); break;",
	"		case 'd': state_tables++; break;",
	"		case 'f': fairness = 1; break;",
	"#ifndef VERI",
	"		case 'l': loops = 1; break;",
	"#endif",
	"		case 'm': maxdepth = atoi(&argv[1][2]); break;",
	"		case 'w': ssize = atoi(&argv[1][2]); break;",
	"		case 'X': efd = stdout; break;",
	"		case 'V': printf(\"Generated by %%s\\n\", Version);",
	"			  exit(0); break;",
	"		default : usage(efd); exit(1);",
	"		}",
	"		argc--; argv++;",
	"	}",
	"	if (acycles && loops)",
	"	{	fprintf(efd, \"sorry: cannot combine -a and -l\\n\");",
	"		usage(efd); exit(1);",
	"	}",
	"	if (fairness && !acycles && !loops)",
	"	{	fprintf(efd, \"sorry: option -f only has effect when\");",
	"		fprintf(efd, \" combined with -a or -l\\n\");",
	"		usage(efd); exit(1);",
	"	}",
	"	signal(SIGINT, wrapup);",
	"	mask = ((1<<ssize)-1);	/* hash init */",
	"	trail = (Trail *) emalloc((maxdepth+2)*sizeof(Trail));",
	"	run();",
	"	done = 1;",
	"	wrapup();",
	"}\n",
	"usage(fd)",
	"	FILE *fd;",
	"{	fprintf(fd, \"unknown option\\n\");",
	"#if CONNECT>0",
	"	fprintf(fd, \"-a  find acceptance cycles\\n\");",
	"#else",
	"	fprintf(fd, \"-a  disabled (no accept labels are defined)\\n\");",
	"#endif",
	"	fprintf(fd, \"-cN stop at Nth error \");",
	"	fprintf(fd, \"(default=1)\\n\");",
	"	fprintf(fd, \"-d  print state tables and stop\\n\");",
	"	fprintf(fd, \"-d -d  print un-optimized state tables\\n\");",
	"	fprintf(fd, \"-f  enforce weak fairness in cycles\\n\");",
	"#ifndef VERI",
	"	fprintf(fd, \"-l  find non-progress cycles\\n\");",
	"#else",
	"	fprintf(fd, \"-l  disabled (by presence of never claim)\\n\");",
	"#endif",
	"	fprintf(fd, \"-mN max depth N (default=10k)\\n\");",
	"	fprintf(fd, \"-wN hashtable of 2^N entries \");",
	"	fprintf(fd, \"(default=%%d)\\n\", ssize);",
	"	fprintf(fd, \"-V  print SPIN version number and exit\\n\");",
	"}\n",
#if 0
/* the library malloc behaves extremely
 * poorly on sysV machines - replaced with a simpler scheme
 */
	"char *",
	"emalloc(n)",
	"{	char *tmp = malloc(n);",
	"#ifdef MEMCNT",
	"	if (!tmp || memcnt > 1<<MEMCNT)",
	"#else",
	"	if (!tmp)",
	"#endif",
	"	{	printf(\"pan: out of memory\\n\");",
	"		wrapup();",
	"	}",
	"#ifdef MEMCNT",
	"	memcnt += n;",
	"#endif",
	"	memset(tmp, 0, n);",
	"	return tmp;",
	"}\n",
#else
	"/* include realloc and free to keep sysV libc",
	" * from including them and",
	" * finding multiple references",
	" */",
	"char *",
	"realloc(s)",
	"	char *s;",
	"{	printf(\"aborting: cannot happen - call on realloc()\\n\");",
	"	wrapup();",
	"	return (char *)0;	/* doesn't get here */",
	"}",
	"",
	"free(s)",
	"	char *s;",
	"{	/* never called - simply ignore it */",
	"}",
	"",
	"char *",
	"malloc(n)",
	"	unsigned n;",
	"{",
	"	char *tmp;",
	"	extern char *sbrk();",
	"	tmp = sbrk(n);",
	"#ifdef MEMCNT",
	"	if ((int) tmp == -1 || memcnt > 1<<MEMCNT)",
	"#else",
	"	if ((int) tmp == -1)",
	"#endif",
	"	{       printf(\"aborting: out of memory\\n\");",
	"		wrapup();",
	"	}",
	"#ifdef MEMCNT",
	"	memcnt += n;",
	"#endif",
	"	return tmp;",
	"}",
	"",
	"#define CHUNK	4096",
	"",
	"char *",
	"emalloc(n)      /* memory is never released or reallocated */",
	"	unsigned n;",
	"{",
	"	char *tmp;",
	"	static char *have;",
	"	static long left = 0L;",
	"	static long fragment = 0L;",
	"",
	"	if (n == 0)",
	"	        return (char *) NULL;",
	"	if (n&3)",
	"	        n += 4-(n&3);	/* for proper alignment */",
	"	if (left < n)",
	"	{       unsigned grow = (n < CHUNK) ? CHUNK : n;",
	"	        have = malloc(grow);",
	"	        fragment += left;",
	"	        left = grow;",
	"	}",
	"	tmp = have;",
	"	have += (long) n;",
	"	left -= (long) n;",
	"",
	"	memset(tmp, 0, n);",
	"	return tmp;",
	"}",
#endif
	"Uerror(str)",
	"	char *str;",
	"{	/* always fatal */",
	"	uerror(str);",
	"	wrapup();",
	"}\n",
	"uerror(str)",
	"	char *str;",
	"{",
	"	if (++errors == upto)",
	"	{	printf(\"pan: %%s (at depth %%d)\\n\", str,",
	"		(depthfound==-1)?depth:depthfound);",
	"		putrail();",
	"		wrapup();",
	"	}",
	"	return 1;",
	"}\n",
	"r_ck(which, N, M, src)",
	"	uchar *which;",
	"	short *src;",
	"{	int i, m=0;\n",
	"#ifdef VERI",
	"	if (M == VERI) return;	/* no useful info there */",
	"#endif",
	"	printf(\"unreached in proctype %%s:\\n\", procname[M]);",
	"	for (i = 1; i < N; i++)",
	"	  if (which[i] == 0)",
	"	  	xrefsrc(src[i], M, i);",
	"	  else",
	"		m++;",
	"	printf(\"\t(%%d of %%d states)\\n\", N-1-m, N-1);",
	"}\n",
	"xrefsrc(lno, M, i)",
	"{",
	"	printf(\"\\tline %%d, state %%d\", lno, i);",
	"	if (trans[M][i] && trans[M][i]->tp)",
	"	{	if (strcmp(trans[M][i]->tp, \"\") != 0)",
	"			printf(\", \\\"%%s\\\"\", trans[M][i]->tp);",
	"		else if (stopstate[M][i])",
	"			printf(\", -endstate-\");",
	"	} else",
	"		printf(\", ?\");",
	"	printf(\"\\n\");",
	"}\n",
	"putrail()",
	"{	int fd, i, j, q;",
	"	char snap[64];\n",
	"	if ((fd = creat(\"pan.trail\", 0666)) <= 0)",
	"	{	printf(\"cannot create pan.trail\\n\");",
	"		return;",
	"	}",
	"#ifdef VERI",
	"	sprintf(snap, \"-2:%%d:-2:-2\\n\", VERI);",
	"	write(fd, snap, strlen(snap));",
	"#endif",
	"	for (i = 1, j = 0; i <= depth; i++)",
	"	{	q = trail[i].pr;",
	"		if (i == depthfound)",
	"			write(fd, \"-1:-1:-1:-1\\n\", 12);",
	"		if (loops)",
	"#ifdef VERI",
	"		{	if (q == 2) continue;",
	"			if (q  > 2) q -= 2;",
	"		}",
	"#else",
	"		{	if (q == 1) continue;",
	"			if (q  > 1) q--;",
	"		}",
	"#endif",
	"		if (trail[i].o_t->ist)",
	"		{  sprintf(snap, \"%%d:%%d:%%d:%%d\\n\", j++,",
	"				q, trail[i].o_t->ist, i);",
	"		   write(fd, snap, strlen(snap));",
	"		}",
	"		sprintf(snap, \"%%d:%%d:%%d:%%d\\n\", j++, ",
	"			q, trail[i].o_t->st, i);",
	"		write(fd, snap, strlen(snap));",
	"	}",
	"	printf(\"pan: wrote pan.trail\\n\");",
	"	close(fd);",
	"}\n",
	"sv_save()	/* push state vector onto save stack */",
	"{	if (!svtack->nxt)",
	"	{  svtack->nxt = (Svtack *) emalloc(sizeof(Svtack));",
	"	   svtack->nxt->body = emalloc(vsize*sizeof(char));",
	"	   svtack->nxt->lst = svtack;",
	"	   svtack->nxt->m_delta = vsize;",
	"	   svmax++;",
	"	} else if (vsize > svtack->nxt->m_delta)",
	"	{  svtack->nxt->body = emalloc(vsize*sizeof(char));",
	"	   svtack->nxt->lst = svtack;",
	"	   svtack->nxt->m_delta = vsize;",
	"	   svmax++;",
	"	}",
	"	svtack = svtack->nxt;",
	"#if SYNC",
	"	svtack->o_boq = boq;",
	"#endif",
	"	svtack->o_delta = vsize;",
	"	memcpy((char *)(svtack->body), (char *)&now, vsize);",
	"}\n",
	"sv_restor()	/* pop state vector from save stack */",
	"{	memcpy((char *)&now, svtack->body, svtack->o_delta);",
	"#if SYNC",
	"	boq = svtack->o_boq;",
	"#endif",
	"	if (vsize != svtack->o_delta)",
	"		Uerror(\"sv_restor\");",
	"	if (!svtack->lst)",
	"		Uerror(\"error: v_restor\");",
	"	svtack  = svtack->lst;",
	"}\n",
	"p_restor(h)",
	"{	int i; char *z = (char *) &now;",
	"	proc_offset[h] = stack->o_offset;",
	"	proc_skip[h]   = stack->o_skip;",
	"	vsize += stack->o_skip;",
	"	memcpy(z+vsize, stack->body, stack->o_delta);",
	"	vsize += stack->o_delta;",
	"	i = stack->o_delqs;",
	"	now._nr_pr += 1;",
	"	if (!stack->lst)	/* debugging */",
	"		Uerror(\"error: p_restor\");",
	"	stack = stack->lst;",
	"	this = pptr(h);",
	"	while (i-- > 0)",
	"		q_restor();",
	"}\n",
	"q_restor()",
	"{	char *z = (char *) &now;",
	"	q_offset[now._nr_qs] = stack->o_offset;",
	"	q_skip[now._nr_qs]   = stack->o_skip;",
	"	vsize += stack->o_skip;",
	"	memcpy(z+vsize, stack->body, stack->o_delta);",
	"	vsize += stack->o_delta;",
	"	now._nr_qs += 1;",
	"	if (!stack->lst)	/* debugging */",
	"		Uerror(\"error: q_restor\");",
	"	stack = stack->lst;",
	"}\n",
	"delproc(sav, h)",
	"{	int d, i=0;",
	"",
	"	if (h+1 != now._nr_pr) return 0;",
	"",
	"	while (now._nr_qs",
	"	&&     q_offset[now._nr_qs-1] > proc_offset[h])",
	"	{	delq(sav);",
	"		i++;",
	"	}",
	"	d = vsize - proc_offset[h];",
	"	if (sav)",
	"	{	if (!stack->nxt)",
	"		{	stack->nxt = (Stack *)",
	"				emalloc(sizeof(Stack));",
	"			stack->nxt->body = ",
	"				emalloc(Maxbody*sizeof(char));",
	"			stack->nxt->lst = stack;",
	"			smax++;",
	"		}",
	"		stack = stack->nxt;",
	"		stack->o_offset = proc_offset[h];",
	"		stack->o_skip   = proc_skip[h];",
	"		stack->o_delta  = d;",
	"		stack->o_delqs  = i;",
	"		memcpy(stack->body, (char *)pptr(h), d);",
	"	}",
	"	vsize = proc_offset[h];",
	"	now._nr_pr = now._nr_pr - 1;",
	"	memset((char *)pptr(h), 0, d);",
	"	vsize -= proc_skip[h];",
	"	return 1;",
	"}\n",
	"delq(sav)",
	"{	int h = now._nr_qs - 1;",
	"	int d = vsize - q_offset[now._nr_qs - 1];",
	"	if (sav)",
	"	{	if (!stack->nxt)",
	"		{	stack->nxt = (Stack *)",
	"				emalloc(sizeof(Stack));",
	"			stack->nxt->body = ",
	"				emalloc(Maxbody*sizeof(char));",
	"			stack->nxt->lst = stack;",
	"			smax++;",
	"		}",
	"		stack = stack->nxt;",
	"		stack->o_offset = q_offset[h];",
	"		stack->o_skip   = q_skip[h];",
	"		stack->o_delta  = d;",
	"		memcpy(stack->body, (char *)qptr(h), d);",
	"	}",
	"	vsize = q_offset[h];",
	"	now._nr_qs = now._nr_qs - 1;",
	"	memset((char *)qptr(h), 0, d);",
	"	vsize -= q_skip[h];",
	"}\n",
	"prognow()",
	"{",
	"	int i; P0 *ptr;",
	"	for (i = 0; i < now._nr_pr; i++)",
	"	{	ptr = (P0 *) pptr(i);",
	"		if (progstate[ptr->_t][ptr->_p])",
	"			return 1;",
	"	}",
	"	return 0;",
	"}\n",
	"endstate()",
	"{	int i; P0 *ptr;",
	"	for (i = 0; i < now._nr_pr; i++)",
	"	{",
	"#ifdef VERI",
	"		if (i == 1) continue;",
	"#endif",
	"		ptr = (P0 *) pptr(i);",
	"		if (!stopstate[ptr->_t][ptr->_p])",
	"			return 0;",
	"	}",
	"	if (loops)",
	"		uerror(\"non progress sequence\");",
	"	return 1;",
	"}\n",
	"onstack()",
	"{	register Svtack *ptr;",
	"	register char *won = (char *)&now;",
	"	register int j=depth;",
	"	for (ptr = svtack; ptr; ptr = ptr->lst, j--)",
	"	if (ptr->o_delta == vsize",
	"	&&  ptr->j1 == J1 && ptr->j2 == J2",
	"	&&  memcmp(ptr->body, won, vsize) == 0)",
	"	{	depthfound = j;",
	"		return 1;",
	"	}",
	"	return 0;",
	"}\n",
	"fair_cycle()",
	"{	int II, i, j, q, odepth;",
	"	Trans *t;",
	"	short tt;",
	"	char ot;",
	"	uchar moved[MAXPROC];",
	"",
	"	if (!fairness) return 1;",
	"	memset(moved, 0, MAXPROC);",
	"#ifdef VERI",
	"	moved[1] = 1;",
	"	if (loops) moved[2] = 1;",
	"#else",
	"	if (loops) moved[1] = 1;",
	"#endif",
	"	for (i = depthfound; i <= depth; i++)",
	"	{	q = trail[i].pr;",
	"#ifdef VERI",
	"		if (q == 1 || (loops && q == 2)) continue;",
	"#else",
	"		if (loops && q == 1) continue;",
	"#endif",
	"		moved[q] = 1;",
	"	}",
	"	odepth = depth;",
	"	for (II = 0; II < now._nr_pr; II++)",
	"	{	if (!moved[II])",
	"		{	this = pptr(II);",
	"			tt = (short) ((P0 *)this)->_p;",
	"			ot = (uchar) ((P0 *)this)->_t;",
	"			for (t = trans[ot][tt]; t; t = t->nxt)",
	"			{",
	"#include \"pan.f\"",
	"#if 0",
	"/* REMOVED - a local self-loop is not always a global self-loop */",
	"				if (tt == t->st) /* executable self-loop */",
	"				{	if (errors+1 == upto)",
	"					{	/* extend the trail */",
	"						depth++; trpt++;",
	"						trpt->pr  = II;",
	"						trpt->o_t = t;",
	"					}",
	"					continue;",
	"				}",
	"#endif",
	"				goto not_fair;",
	"			}",
	"		}",
	"	}",
	"	/* a fair cycle was detected */",
	"	for (i = depthfound-1; i <= depth; i++)",
	"		trail[i].tau &= ~2;	/* unmark states in SCC */",
	"	return 1;",
	"not_fair:",
	"#if 0",
	"/* REMOVED - part of the self-loop detection code */",
	"	while (depth > odepth)	/* undo trail updates */",
	"	{	depth--; trpt--;",
	"	}",
	"#endif",
	"	for (i = depthfound-1; i <= depth; i++)",
	"		trail[i].tau |= 2;	/* mark states in SCC */",
	"	return 0;",
	"}\n",

	"#if CONNECT>0",
	"checkaccept()",
	"{	int i;",
	"       for (i = 0; i < now._nr_pr; i++)",
	"       {       P0 *ptr = (P0 *) pptr(i);",
	"               if (accpstate[ptr->_t][ptr->_p])",
	"			break;",
	"	}",
	"	if (i == now._nr_pr)",
	"		return;",
	"	if (now._a_t)",
	"	{",
	"		return;",
	"	}",
	"	now._a_t = 13;	/* 13 to help the hasher */",
	"	A_depth = depth;",
	"	memcpy((char *)&A_Root, (char *)&now, vsize);",
	"	depthfound = depth;",
	"	new_state();	/* the 2nd search */",
	"	depthfound = -1;",
	"	now._a_t = 0;",
	"}\n",
	"#endif\n",

	"#ifndef BITSTATE",
	"struct H_el {",
	"	struct H_el *nxt;",
	"	unsigned tagged;",
	"	unsigned state;",
	"} **H_tab;\n",
	"hinit()",
	"{	H_tab = (struct H_el **)",
	"		emalloc((1<<ssize)*sizeof(struct H_el *));",
	"}\n",
	"struct H_el *Free_list = 0;	/* recycles removed states  */",
	"",
	"recycle_state(v, n)",
	"	struct H_el *v;",
	"	short n;",
	"{",
	"	struct H_el *tmp, *last = 0;",
	"	v->tagged = n;",
	"	v->nxt = 0;",
	"	for (tmp = Free_list; tmp; last = tmp, tmp = tmp->nxt)",
	"	{	if (tmp->tagged >= n)",
	"		{	if (last)",
	"			{	v->nxt = tmp->nxt;",
	"				last->nxt = v;",
	"			} else",
	"			{	v->nxt = Free_list;",
	"				Free_list = v;",
	"			}",
	"			return;",
	"		}",
	"		if (!tmp->nxt)",
	"		{	tmp->nxt = v;",
	"			return;",
	"	}	}",
	"	Free_list = v;",
	"}",
	"",
	"struct H_el *",
	"grab_state(n)",
	"{	struct H_el *tmp, *last = 0;",
	"",
	"	for (tmp = Free_list; tmp; last = tmp, tmp = tmp->nxt)",
	"		if (tmp->tagged == n)",
	"		{	if (last)",
	"				last->nxt = tmp->nxt;",
	"			else",
	"				Free_list = tmp->nxt;",
	"			tmp->nxt = 0;",
	"			recycled++;",
	"			return tmp;",
	"		}",
	"	return (struct H_el *)",
	"	      emalloc(sizeof(struct H_el)+n-sizeof(unsigned));",
	"}",
	"",
	"htag(v, n)",
	"	char *v;",
	"	short n;",
	"{",
	"	register struct H_el *tmp, *last = 0;",
	"	s_hash(v, n);",
	"	for (tmp = H_tab[j1]; tmp; last = tmp, tmp = tmp->nxt)",
	"	{	if (memcmp(((char *)&(tmp->state)), v, n) == 0)",
	"		{	tmp->tagged &= (1<<30);	/* not on stack */",
	"			if (trpt->tau&2) /* remove marked state */",
	"			{	if (last)",
	"					last->nxt = tmp->nxt;",
	"				else",
	"					H_tab[j1] = tmp->nxt;",
	"				recycle_state(tmp, n);",
	"			}",
	"			return;",
	"		}",
	"	}",
	"	Uerror(\"cannot happen, htag\");",
	"}\n",
	"hstore(v, n)",
	"	char *v;",
	"	short n;",
	"{",
	"	register struct H_el *tmp; int m;\n",
	"	struct H_el *ntmp, *olst = (struct H_el *) 0;\n",
	"	s_hash((uchar *)v, n);",
	"	tmp = H_tab[j1];",
	"	if (!tmp)",
	"	{  tmp = grab_state(n);",
	"	   H_tab[j1] = tmp;",
	"	} else",
	"	{  for (;; hcmp++, olst = tmp, tmp = tmp->nxt)",
	"	   {   m = memcmp(&(tmp->state), v, n);",
	"	       if (m == 0)",
	"	       {	if (tmp->tagged & ~(1<<30)",
	"			&&  loops && now._p_t)",
	"			{	depthfound = tmp->tagged&~(1<<30);",
	"				if (fair_cycle())",
	"				uerror(\"non-progress cycle\");",
	"			}",
	"			return 1; /* match outside stack */",
	"	       } else if (m < 0)",
	"	       {	/* insert state before tmp */",
	"			ntmp = grab_state(n);",
	"			ntmp->nxt = tmp;",
	"			if (!olst)",
	"				H_tab[j1] = ntmp;",
	"			else",
	"				olst->nxt = ntmp;",
	"			tmp = ntmp;",
	"			break;",
	"	       } else if (!tmp->nxt)",
	"	       {	/* append after tmp */",
	"			tmp->nxt = (struct H_el *)",
	"			emalloc(sizeof(struct H_el)+n-sizeof(unsigned));",
	"			tmp = tmp->nxt;",
	"			break;",
	"	   }   }",
	"	}",
	"	tmp->tagged = depth+1; /* non-zero while on stack */",
	"	memcpy(((char *)&(tmp->state)), v, n);",
	"	return 0;",
	"}",
	"#endif",
	"#include \"pan.t\"",
	"",
	"do_reach()",
	"{",
	0,
};
